using System;
using System.IO;
using System.Text.RegularExpressions;
using System.Text;
using System.Linq;

/* contents: listed on GitHub with 30 methods as gist stringLibrary_v12 added 11th Sept 2018

BuildSimpleConsoleAppCode() added for v12
CleanFileName() added for v12
Entitle() added for v12
FixMalformedSourceCodeFileExtension() added for v12
nthToStringWithOrdinalSuffix() added for v12
NumberOfSpecificCharactersInString() added for v12
RemoveSubstringFromString() added for v12
TrimTrailingCharacters() added for v12

ByteArrayToString() translates a byte array of ascii codes into a string
ContainsNonAlphanumeric() returns true if string contains any character not a digit and not a letter
ContainsNonAlphanumeric() overload allows exclusion of spaces when determining presence of non-alphanumerics
DateTimeToFilenamePrefix() returns string based on current date and time (ex: 30Aug2018_1105)
DateTimeToFilenamePrefix() overload taking a string parameter
DaysTillNextBirthday() returns integer number of days till next birthday
GetDiffInWholeYears() returns # of whole years between two dates
HowManyNumerals() returns number of digits found in passed string argument
IndexOfNonAlphanumericCharacter() returns the index of the first-encountered non-alphanumeric character in a string
IntegerToAbbreviatedMonth() takes month (ex: 8) and returns abbreviation (ex: Aug)
IsAlphabetical() returns true only if ALL characters in passed string are alphabetical
IsNonAlphaNumChar() returns true if character: (1) isn't a letter, and (2) isn't a digit
ParseableToDateType() returns true if string argument can be successfully parsed to DateTime
ParseableToInteger() returns true if string argument can be successfully parsed to integer
ProperlyCapitalizeName() assumes passed string is person's name; prunes excess spaces and capitalizes
StringToByteArray() takes string argument and returns byte array containing its characters' ASCII codes
ShowByteEncodingForString() wraps StringToByteArray(); returns string rep of passed string's ASCII encoding
Write() does same as Console.Write() except appends one space before written contents
WriteGreen() does same as Console.Write() but with green foreground console color
WriteYellow() does same as Console.Write() but with yellow foreground console color
WriteLine() does same as Console.WriteLine() except appends one space before written contents
WriteQ() does same as Write() except places written argument in quotation marks
WriteLineQ() does same as WriteLine() except places written argument in quotation marks
*/
namespace com.wms.strings
{
	public class MyConsole
	{		
		public static void Entitle(string sProgrammer, string programmerEmailAddress, string sExeName)
		{
			string sBorder = "===========================================================";
			Console.WriteLine("\n");
			MyConsole.WriteYellow(" " + sBorder + "\n");
			DateTime dt = DateTime.Today;
			string sDT = dt.ToShortDateString();
			string line1a = "Compiled by: ";
			string line1b = sProgrammer;
			
			int iDiff = sBorder.Length - line1a.Length - line1b.Length;
			int iFirstLinePrependedSpaces = iDiff/2;
			string sFirstLine = string.Empty;
			for(int i=0; i < iFirstLinePrependedSpaces; i++){
				sFirstLine += " ";
			}
			MyConsole.Write(sFirstLine + line1a);
			MyConsole.WriteGreen(line1b + "\n");
			
			int iDiff2 = sBorder.Length - sDT.Length - programmerEmailAddress.Length - 4;
			string sSecondLine = string.Empty;
			int iSecondLinePrependedSpaces = iDiff2/2;
			for(int i=0; i < iSecondLinePrependedSpaces; i++){
				sSecondLine += " ";
			}
			MyConsole.Write(sSecondLine + "(" + sDT + " <" + programmerEmailAddress + ">)\n"); 
			
			int iDiff3 = sBorder.Length - sExeName.Length;
			string sThirdLine = string.Empty;
			int iThirdLinePrependedSpaces = iDiff3/2;
			for(int i=0; i < iThirdLinePrependedSpaces; i++){
				sThirdLine += " ";
			}
			sThirdLine += sExeName;
			MyConsole.WriteGreen(sThirdLine + "\n");
			
			MyConsole.WriteYellow(" " + sBorder + "\n\n");			
		}
		
		public static void Write(string p)
		{
			Console.Write(" " + p);
		}
		
		public static void WriteGreen(string p)
		{
			Console.BackgroundColor = ConsoleColor.Black;
			Console.ForegroundColor = ConsoleColor.Green;
			Console.Write(p);
			Console.ForegroundColor = ConsoleColor.White;
		}
		
		public static void WriteYellow(string p)
		{
			Console.BackgroundColor = ConsoleColor.Black;
			Console.ForegroundColor = ConsoleColor.Yellow;
			Console.Write(p);
			Console.ForegroundColor = ConsoleColor.White;
		}
		
		public static void WriteQ(string p)
		{
			Console.Write(" \"" + p + "\"");
		}
		
		public static void WriteLine(string p)
		{
			Console.WriteLine(" " + p);
		}
		
		public static void WriteLineQ(string p)
		{
			Console.WriteLine(" \"" + p + "\"");
		}
	}
	
	public class StringManipulator		
	{
		
		public const string MatchEmailPattern =
           @"^[a-zA-Z][\w\.-]*[a-zA-Z0-9]@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z]$";
					
		public static string BuildConsoleAppBatchBuilder(string _filename)
		{
			string sJustBaseName = Path.GetFileNameWithoutExtension(_filename);
			StringBuilder sb =new StringBuilder(300);
			sb.Append("csc @strLibResp.rsp\n");
			sb.Append("csc @ioLibResp.rsp\n");
			sb.Append("csc @" + sJustBaseName + "Resp.rsp");
			return sb.ToString();
		}
					
		public static string BuildAppResponseFile(string _filename)
		{
			_filename = Path.GetFileName(_filename);
			StringBuilder sb = new StringBuilder(350);
			sb.Append("/target:exe\n");
			sb.Append("/out:");
			string temp = RemoveSubstringFromString(_filename, "Resp.rsp");
			sb.Append(temp);
			sb.Append(".exe\n");
			sb.Append("/nowin32manifest\n");
			sb.Append("/nologo\n");
			sb.Append("/r:ioLib.dll\n");
			sb.Append("/r:strLib.dll\n");
			string temp2 = RemoveSubstringFromString(_filename, "Resp.rsp");
			sb.Append(temp2);
			sb.Append(".cs");
			return sb.ToString();
		}
					
		public static string BuildIoLibraryResponseFile()
		{
			StringBuilder sb = new StringBuilder(300);
			
			sb.Append("/nologo\n");
			sb.Append("/target:library\n");
			sb.Append("/r:System.IO.Compression.dll\n");
			sb.Append("/r:System.IO.Compression.FileSystem.dll\n");
			sb.Append("/out:ioLib.dll\n");
			sb.Append("C:\\csdev\\library\\ioLibrary.cs\"");
			return sb.ToString();
		}
		
		public static string BuildStringLibraryResponseFile()
		{
			StringBuilder sb = new StringBuilder(300);
			sb.Append("/nologo\n");
			sb.Append("/target:library\n");
			sb.Append("/out:strLib.dll\n");
			sb.Append("C:\\csdev\\library\\stringLibrary.cs\"");
			return sb.ToString();
		}
		
		public static string BuildSimpleConsoleAppCode(string fullpath, bool includeTitle)
		{
			string sBaseName = Path.GetFileNameWithoutExtension(fullpath);
			string sCoderName = string.Empty;
			string sCoderEmail = string.Empty;
			StringBuilder sb = new StringBuilder(550);
			Console.WriteLine(" Invoking StringManipulator.BuildSimpleConsoleAppCode()...");
			sb.Append("using System;\n");
			sb.Append("using com.wms.strings;\n");
			sb.Append("using com.wms.io;\n\n");
			sb.Append("namespace MyProgramNamespace{\n");
			sb.Append("\tclass Program{\n");
			sb.Append("\t\tstatic void Main(){\n\n");
			sb.Append("\t\t\t//insert code here...\n");
			if(includeTitle){
				if(File.Exists(@"C:\csdev\user\nameemail.txt")){
					string temp = File.ReadAllText(@"C:\csdev\user\nameemail.txt");
					Console.WriteLine(" Successfully read data from C:\\csdev\\user\\nameemail.txt...");
					temp = temp.Trim();
					int indexLessThan = temp.IndexOf("<");
					if(indexLessThan > 4){
						sCoderName = temp.Substring(1, indexLessThan -1).Trim();
						Console.WriteLine(" StringManipulator.BuildSimpleConsoleAppCode() extracted name \"{0}\"", sCoderName);
					}else{
						Console.WriteLine(" Didn't find symbol < where expected...");
					}
					int indexGreaterThan = temp.IndexOf(">");
					if((indexGreaterThan > 0) && (indexGreaterThan > indexLessThan)){
						sCoderEmail = temp.Substring((indexLessThan + 1), (indexGreaterThan - (indexLessThan + 1)));
						Console.WriteLine(" StringManipulator.BuildSimpleConsoleAppCode() extracted email:");
						Console.WriteLine("\t\"{0}\"", sCoderEmail);
					}
					if(sCoderEmail.Length > 0){
						if(sCoderName.Length > 0){
							sb.Append("\t\t\tMyConsole.Entitle(");
							sb.Append("\"" + sCoderName + "\"");
							sb.Append(", ");
							sb.Append("\"" + sCoderEmail + "\", ");
							sb.Append("\"" + sBaseName);
							if(!sBaseName.EndsWith(".exe")){
								sb.Append(".exe");
							}
							sb.Append("\"");
							sb.Append(");");
							sb.Append("\n");
						}
					}
				}else{
					Console.WriteLine(" Didn't find file C:\\csdev\\user\\nameemail.txt");
				}
			}
			sb.Append("\t\t\tConsole.WriteLine(\" Hello world!\");\n\n");
			sb.Append("\t\t\tMyConsole.Write(\"To exit ");
			sb.Append(sBaseName + ".exe, press any key...\");\n");
			sb.Append("\t\t\tConsole.ReadLine();\n");
			sb.Append("\t\t\tConsole.WriteLine();");
			sb.Append("\n\t\t}\n");
			sb.Append("\t}\n");
			sb.Append("}");
			return sb.ToString();
		}
					
		public static string ByteArrayToString(byte[] p)
		{
			string result = string.Empty;
			
			foreach(byte b in p)
			{
				result += Convert.ToChar(b);
			}
			
			return result;
		}
		
		public static string CleanFileName(string fileName)
		{
			string result = Path.GetInvalidFileNameChars().Aggregate(fileName, (current, c) => current.Replace(c.ToString(), string.Empty));
			
			if(result.Length >= 4){
				if(NumberOfSpecificCharactersInString(result, '.') == 1){
					if(result.EndsWith(".cs")){
						return result;
					}
				}
			}
			
			while(result.EndsWith(".")){
				result = StringManipulator.TrimTrailingCharacters(result, '.');
			}			
			if(NumberOfSpecificCharactersInString(result, '.') > 1){					
				string[] tokens = result.Split('.');
				result = string.Empty;
				foreach(string p in tokens){
					result += p;					
				}								
			}				

			return result;
		}		
		
		public static bool ContainsNonAlphanumeric(string p, bool excludeSpaces){
			bool result = false;
			if(IndexOfNonAlphanumericCharacter(p, excludeSpaces) > -1){ result = true;}
			return result;
		}
		
        public static int DaysTillNextBirthday(DateTime dateOfBirth)
        {
            //full days (whole, 24-hr periods) until next birthday...
            int result = 0;
            DateTime dtToday = DateTime.Now;
            DateTime dtNextBirthday = new DateTime(dtToday.Year, dateOfBirth.Month, dateOfBirth.Day);
            TimeSpan tsDifference = dtNextBirthday - dtToday;

            if (tsDifference.Days < 0)
            {
                //already had birthday this year
                tsDifference = dtNextBirthday.AddYears(1) - dtToday;
            }
            result = tsDifference.Days;
            return result;
        }		
		
		public static string DateTimeToFilenamePrefix()
		{
			string result = string.Empty;
			string sDT = DateTime.Now.ToString();
			string[] parts = sDT.Split(default (Char[]), StringSplitOptions.RemoveEmptyEntries);
			string part0 = parts[0];
			
			//parse out the date (month/day/year)
			char[] splitChar = {'/'};
			string[] date_parts = part0.Split(splitChar);
			int month = Int32.Parse(date_parts[0]);
			int day = Int32.Parse(date_parts[1]);
			int year = Int32.Parse(date_parts[2]);
			string date_portion = day.ToString() + IntegerToAbbreviatedMonth(month) + year.ToString();
			
			//parse out the time (hr/min/sec)
			char[] splitChar2 = {':'};
			string part1 = parts[1];
			string[] time_parts = part1.Split(splitChar2);
			
			int hrs = Int32.Parse(time_parts[0]);
			int min = Int32.Parse(time_parts[1]);
			int sec = Int32.Parse(time_parts[2]);
			
			if(parts[2] == "PM"){				
				hrs += 12;
			}
			
			string hr_portion = hrs.ToString();
			if(hr_portion.Length < 2){ hr_portion = "0" + hr_portion;}
			
			string min_portion = min.ToString();
			if(min_portion.Length < 2){ min_portion = "0" + min_portion;}
						
			string time_portion = hr_portion + min_portion;
			
			result = date_portion + "_" + time_portion;
			return result;
		}
		
		public static string DateTimeToFilenamePrefix(string _dt)
		{
			string sDT = DateTime.Now.ToString();
			string result = string.Empty;
			if(ParseableToDateTime(_dt)){
				sDT = _dt;
			}
						
			string[] parts = sDT.Split(default (Char[]), StringSplitOptions.RemoveEmptyEntries);
			string part0 = parts[0];
			
			//parse out the date (month/day/year)
			char[] splitChar = {'/'};
			string[] date_parts = part0.Split(splitChar);
			int month = Int32.Parse(date_parts[0]);
			int day = Int32.Parse(date_parts[1]);
			int year = Int32.Parse(date_parts[2]);
			string date_portion = day.ToString() + IntegerToAbbreviatedMonth(month) + year.ToString();
			
			//parse out the time (hr/min/sec)
			char[] splitChar2 = {':'};
			string part1 = parts[1];
			string[] time_parts = part1.Split(splitChar2);
			
			int hrs = Int32.Parse(time_parts[0]);
			int min = Int32.Parse(time_parts[1]);
			int sec = Int32.Parse(time_parts[2]);
			
			if(parts[2] == "PM"){				
				hrs += 12;
			}
			
			string hr_portion = hrs.ToString();
			if(hr_portion.Length < 2){ hr_portion = "0" + hr_portion;}
			
			string min_portion = min.ToString();
			
			if(min_portion.Length < 2){ min_portion = "0" + min_portion;}			
			
			string time_portion = hr_portion + min_portion;
			
			result = date_portion + "_" + time_portion;
			return result;
		}		
		
		public static string DerivePathForAutoGenConsoleProgramBatchFile(string sSeedFile)
		{
			string _full = sSeedFile;
			MyConsole.WriteLine("Deriving full path for batch file for autogen src file...");
			
			if(!_full.Contains("//")){
				_full = _full.Replace(".cs",".bat");
			}else{
				_full = _full.Replace(".cs",".bat");
			}
			
			//MyConsole.WriteLine("Derived path: " + _full);
			
			return _full;
		}
		
		public static int GetDiffInWholeYears(DateTime startDate, DateTime endDate)
		{
			//Excel documentation says "COMPLETE calendar years in between dates"
			int years = endDate.Year - startDate.Year;
 
			if (startDate.Month == endDate.Month &&// if the start month and the end month are the same
				endDate.Day < startDate.Day// AND the end day is less than the start day
				|| endDate.Month < startDate.Month)// OR if the end month is less than the start month
			{
				years--;
			}
 
			return years;
		}		
		
		public static string FixMalformedSourceCodeFileExtension(string p)
		{
			//ensures parameter p is converted to a filename that has a
			//.cs extension
			
			string result = p.Replace(".exe","");
			result = result.Replace(".com","");
			result = result.Replace(".bat","");
			result = result.Replace(".cs","");
			result = result.Replace(".","");
			result += ".cs";
			
			return result;
		}
		
		public static int HowManyNumerals(string p)
		{
			int result = 0;
			string nums = "0123456789";
			
			foreach(char c in p)
			{
				if (nums.Contains(c.ToString()))
				{
					result++;
				}
			}
			
			return result;
		}
		
		public static string IntegerToAbbreviatedMonth(int i)
		{
			string result = string.Empty;
			switch(i)
			{
				case 1:
					result = "Jan";
					break;
				case 2:
					result = "Feb";
					break;
				case 3:
					result = "Mar";
					break;
				case 4:
					result = "Apr";
					break;
				case 5:
					result = "May";
					break;
				case 6:
					result = "Jun";
					break;
				case 7:
					result = "Jul";
					break;
				case 8:
					result = "Aug";
					break;
				case 9:
					result = "Sep";
					break;
				case 10:
					result = "Oct";
					break;
				case 11:
					result = "Nov";
					break;
				case 12:
					result = "Dec";
					break;
				default:
					result = "Undefined";
					break;
			}
			return result;
		}
		
		public static bool IsAlphabetical(string p)
		{
			/*returns true if every character in the passed 
			argument is either a lower- or upper-case letter
			of the English alphabet; false otherwise */
			
			bool result = true;
			
			byte[] word = StringToByteArray(p);
			foreach(byte b in word)
			{
				if(b < 65)
				{ 
					return false;
				}else{
					if (b > 122){
						return false;
					}else{
						if((b > 90) && (b < 97)){
							return false;
						}
					}
				}
				
			}
			
			return result;
		}
		
        public static bool IsEmail(string sEmail) {
            if (sEmail != null) {
                return Regex.IsMatch(sEmail, MatchEmailPattern);
            }
            else {
                //if sEmail is null, we don't test at all
                return false;
            }
        }		
		
        public static bool IsNonAlphaNumChar(char c) {
            if (Char.IsDigit(c)) { return false; }
            if (Char.IsLetter(c)) { return false; }
            return true;
        }

		public static int IndexOfNonAlphanumericCharacter(string p, bool excludeSpaces){
			int index = -1;
					
			if(p.Length < 1){
				//done
			}else{
				char[] chars = p.ToCharArray();
				for(int i=0; i < chars.Length; i++){
					if(IsNonAlphaNumChar(chars[i])){
						if(chars[i] == ' '){
							if(excludeSpaces){
								//ignore
							}else{
								index = i;
								break;								
							}
						}else{
							index = i;
						}

					}
				}
			}
			
			return index;
		}
		
        public static string nthToStringWithOrdinalSuffix(int _num) {
            string s = string.Empty;
			string sLastDigit = _num.ToString();
			sLastDigit = sLastDigit.Substring(sLastDigit.Length - 1, 1);
			string sNextToLastDigit = string.Empty;			
			if(_num > 100){
				sNextToLastDigit = _num.ToString();
				sNextToLastDigit = sNextToLastDigit.Substring(sNextToLastDigit.Length - 2,1);
			}
			
			if((_num >=0)&&(_num <= 20)){
				switch(_num){
					case 1:
						s = "st";
						break;
					case 2:
						s = "nd";
						break;
					case 3:
						s = "rd";
						break;
					default:
						s = "th";
						break;
				}
			}
			
			if((_num > 20) && (_num <= 100)){
				
				switch(sLastDigit){
					case "1":
						s = "st";
						break;
					case "2":
						s = "nd";
						break;
					case "3":
						s = "rd";
						break;
					case "4":
						s = "th";
						break;
					case "5":
						s = "th";
						break;
					case "6":
						s = "th";
						break;
					default:
						s = "th";
						break;
				}
			}
			
            if(_num <= 100){
				return (_num.ToString() + s);
			}else{
				return " Invalid parameter \"" + _num.ToString() + "\": Method nthToStringWithOrdinalSuffix() \n only accepts integers up to 100.";
			}
        }		
		
		public static int NumberOfSpecificCharactersInString(string p, char c)
		{
			int result = 0;
			char[] word = p.ToCharArray();
			foreach(char r in word){
				if(r == c){ result++; }
			}
			return result;
		}		
		
		public static bool ParseableToDateTime(string p)
		{
			bool result = false;
			DateTime dt = DateTime.Now;
			
			if(DateTime.TryParse(p, out dt))
			{
				result = true;
			}
			
			return result;
		}
		
		public static bool ParseableToInteger(string p)
        {
            bool result = false;
            int i;

            if (int.TryParse(p, out i))
            {
                result = true;
            }

            return result;
        }
		
		public static string ProperlyCapitalizeName(string p)
		{	
			string sResult = string.Empty;
			string sFirst = string.Empty;
			string sRemaining = string.Empty;
			
			p = p.Trim();
			if(p.Length >= 2)
			{
				sFirst = p.Substring(0,1).ToUpper();
				sRemaining = p.Substring(1,p.Length -1).ToLower();
				sResult = sFirst + sRemaining;
			}else{
				if(p.Length < 1)
				{
					sResult = "";
				}else{
					sResult = sFirst.ToUpper();
				}
			}
			return sResult;
		}		
		
		public static string RemoveSubstringFromString(string primary_string, string subToRemove)
		{
			if((primary_string.Length > subToRemove.Length)){
				
				if(primary_string.IndexOf(subToRemove) > -1){
					primary_string = primary_string.Replace(subToRemove,"");
				}
			}
			return primary_string;
		}
				
		public static byte[] StringToByteArray(string p)
		{
			byte[] result = Encoding.Default.GetBytes(p);
			return result;
		}
		
		public static string ShowByteEncodingForString(string p)
		{
			string result = string.Empty;
			byte[] btEncoding = StringToByteArray(p);
			foreach(byte b in btEncoding)
			{
				result += b.ToString() + " ";
			}
			return result.Trim();
		}
		
		public static string TrimTrailingCharacters(string p, char c)
		{
			string result = p;
			
			while(result.EndsWith(c.ToString())){
				result = result.Substring(0, result.Length - 1);
			}
			
			return result;
		}
	}
}